# pylint: disable=wrong-spelling-in-comment

feature_types={
	"AcquisitionStart": "comm",
	"AcquisitionStop": "comm",
	"CameraDump": "comm",
	"DDGStepUploadModeValues": "comm",
	"I2CRead": "comm",
	"I2CWrite": "comm",
	"SoftwareTrigger": "comm",
	"TimestampClockReset": "comm",

	"AccumulateCount": "int",
	"AcquiredCount": "int",
	"AOIHBin": "int",
	"AOIHeight": "int",
	"AOILeft": "int",
	"AOIStride": "int",
	"AOITop": "int",
	"AOIVBin": "int",
	"AOIWidth": "int",
	"Baseline": "int",
	"BufferOverflowEvent": "int",
	"CameraMemory": "int",
	"DDGIOCNumberOfPulses": "int",
	"DDGIOCPeriod": "int",
	"DDGOutputDelay": "int",
	"DDGOutputWidth": "int",
	"DDGStepCount": "int",
	"DDGStepUploadProgress": "int",
	"DeviceCount": "int",
	"DeviceVideoIndex": "int",
	"EventsMissedEvent": "int",
	"ExposedPixelHeight": "int",
	"ExposureEndEvent": "int",
	"ExposureStartEvent": "int",
	"FrameCount": "int",
	"I2CAddress": "int",
	"I2CByte": "int",
	"I2CByteCount": "int",
	"I2CByteSelector": "int",
	"ImageSizeBytes": "int",
	"LUTIndex": "int",
	"LUTValue": "int",
	"MCPGain": "int",
	"MCPVoltage": "int",
	"MultitrackCount": "int",
	"MultitrackEnd": "int",
	"MultitrackSelector": "int",
	"MultitrackStart": "int",
	"PortSelector": "int",
	"PreAmpGainValue": "int",
	"PreAmpOffsetValue": "int",
	"RowNExposureEndEvent": "int",
	"RowNExposureStartEvent": "int",
	"SensorHeight": "int",
	"SensorWidth": "int",
	"TimestampClock": "int",
	"TimestampClockFrequency": "int",
	"UsbProductId": "int",
	"UsbDeviceId": "int",

	"AlternatingReadoutDirection": "bool",
	"CameraAcquiring": "bool",
	"CameraPresent": "bool",
	"DDGIOCEnable": "bool",
	"DDGOutputEnable": "bool",
	"DDGOutputStepEnable": "bool",
	"DDGOpticalWidthEnable": "bool",
	"DDGStepEnabled": "bool",
	"DDGStepUploadRequired": "bool",
	"DisableShutter": "bool",
	"EventEnable": "bool",
	"ExternalIOReadout": "bool",
	"FastAOIFrameRateEnable": "bool",
	"ForceShutterOpen": "bool",
	"FrameIntervalTiming": "bool",
	"FullAOIControl": "bool",
	"IODirection": "bool",
	"IOState": "bool",
	"IOInvert": "bool",
	"IRPreFlashEnable": "bool",
	"KeepCleanEnable": "bool",
	"KeepCleanPostExposureEnable": "bool",
	"MCPIntelligate": "bool",
	"MetadataEnable": "bool",
	"MetadataFrame": "bool",
	"MetadataFrameInfo": "bool",
	"MetadataTimestamp": "bool",
	"MultitrackBinned": "bool",
	"Overlap": "bool",
	"PIVEnable": "bool",
	"PreTriggerEnable": "bool",
	"RollingShutterGlobalClear": "bool",
	"ScanSpeedControlEnable": "bool",
	"SensorCooling": "bool",
	"ShutterAmpControl": "bool",
	"ShutterState": "bool",
	"SpuriousNoiseFilter": "bool",
	"StaticBlemishCorrection": "bool",
	"SynchronousTriggering": "bool",
	"TransmitFrames": "bool",
	"VerticallyCentreAOI": "bool",
	
	"BackoffTemperatureOffset": "float",
	"BytesPerPixel": "float",
	"CoolerPower": "float",
	"DDGStepDelayCoefficientA": "float",
	"DDGStepDelayCoefficientB": "float",
	"DDGStepWidthCoefficientA": "float",
	"DDGStepWidthCoefficientB": "float",
	"ExposureTime": "float",
	"ExternalTriggerDelay": "float",
	"FrameInterval": "float",
	"FrameRate": "float",
	"HeatSinkTemperature": "float",
	"InputVoltage": "float",
	"LineScanSpeed": "float",
	"PixelHeight": "float",
	"PixelWidth": "float",
	"ReadoutTime": "float",
	"RowReadTime": "float",
	"SensorTemperature": "float",
	"ShutterTransferTime": "float",
	"TargetSensorTemperature": "float",
	
	"CameraFamily": "str",
	"CameraModel": "str",
	"CameraName": "str",
	"ControllerID": "str",
	"DDR2Type": "str",
	"DriverVersion": "str",
	"FirmwareVersion": "str",
	"MicrocodeVersion": "str",
	"SerialNumber": "str",
	"SoftwareVersion": "str",
	
	"AOIBinning": "enum",
	"AOILayout": "enum",
	"AuxiliaryOutSource": "enum",
	"AuxOutSourceTwo": "enum",
	"BitDepth": "enum",
	"ColourFilter": "enum",
	"CycleMode": "enum",
	"DDGOutputPolarity": "enum",
	"DDGOutputSelector": "enum",
	"DDGStepDelayMode": "enum",
	"DDGStepWidthMode": "enum",
	"ElectronicShutteringMode": "enum",
	"EventSelector": "enum",
	"FanSpeed": "enum",
	"GateMode": "enum",
	"InsertionDelay": "enum",
	"IOControl": "enum",
	"IOSelector": "enum",
	"PixelCorrection": "enum",
	"PixelEncoding": "enum",
	"PixelReadoutRate": "enum",
	"PreAmpGain": "enum",
	"PreAmpGainChannel": "enum",
	"PreAmpGainControl": "enum",
	"PreAmpGainSelector": "enum",
	"SensorReadoutMode": "enum",
	"SensorType": "enum",
	"ShutterMode": "enum",
	"ShutterOutputMode": "enum",
	"SimplePreAmpGainControl": "enum",
	"TemperatureControl": "enum",
	"TemperatureStatus": "enum",
	"TriggerMode": "enum"
}